/*
  Tutorial
  Library for use WiFi as file.
  Created by BJP Budapest, 2021 May 17
  Released into the public domain.
*/

#define __cplusplus  201103L
#include "ESP32_VirtualFileSystem_to_WiFi_Budapest2021may17.h"

WiFiClient client2remoteFS ;
WiFiServer serverFS(80);
IPAddress ip_remote ;


int client_fs_open (const char *path, int flags, int mode){ 
  // put here your device handler (open)
  //printf ("open:  path=%s, flags=0x%04x, mode=0x%04x\n",path,flags,mode);

  uint8_t ipTemp [4] {0,0,0,0};
  uint8_t k = 0 ;
  for (uint8_t i= 0; i<4; i++){
  
    for (uint8_t j= 0; j<4; j++){ 
      k++ ;
      if ( (path[k] == '.') || (((uint8_t)path[k] == 0) ) ){
        break ; 
      }; 
      ipTemp[i] = (10*ipTemp[i]
                   + ((uint8_t)path[k] - (uint8_t)'0')  ) ;
    } ;
  };

  ip_remote = ipTemp ;

  Serial.print("remote IP = "); Serial.println(ip_remote);

  if (!client2remoteFS.connect(ip_remote, 80)) {
      printf ("\nunable to connect to %d.%d.%d.%d\n",
              ipTemp[0],ipTemp[1],ipTemp[2],ipTemp[3]);
      return -1 ;  //  open = false , is_open = 0
  } ;
  
  return 1 ;  // open = true , is_open = 1
    
};  //  client_fs_open



int server_fs_open (const char *path, int flags, int mode){ 
// put here your device handler (open)
//  printf ("open:  path=%s, flags=0x%04x, mode=0x%04x\n",path,flags,mode);
if ( client2remoteFS.connected() ){return 1;};
  client2remoteFS = serverFS.available();
  if (client2remoteFS) {
    ip_remote = client2remoteFS.remoteIP() ;      
    printf("remote IP: %3d.%3d.%3d.%3d\n",ip_remote[0],    
            ip_remote[1],ip_remote[2],ip_remote[3]);   
    return 1 ;  // open = true , is_open = 1
  }
  else {
//    printf("serverFS.available() false\n"); 
    return -1 ;  //  open = false , is_open = 0  
  };

} ;  //  server_fs_open 


ssize_t  server_client_read(int fd, void* dst, size_t size){
  // put here your device handler (read), and delete the next:
  // read 1 (!) char, size == 128 || size == 127
  //  printf ("read: size = %d\n",size);
  
  if ( ! ((size == 128)|| (size == 127)) ) {
    Serial.print("ERROR! size != 128, != 127 - not implemented  ");  
    Serial.print("size ="); Serial.println(size); 
    return 0 ;
  }
  else{
    char* p = (char*)dst ; 
    *p =client2remoteFS.read() ;
    return 1 ;  // number of readed characters
  } ;
} ;


ssize_t  server_client_write(int fd, const void * data, size_t C){
    // put here your device handler (write), and delete the next:

  char* p = (char*)data ; 
//  printf ("write: fd =%d = 0x%02x\n",fd,fd); 
  
  for (uint16_t i = 0 ; i<C ; i++){
    client2remoteFS.write( *p);
    p++ ;  
  };
};


int server_client_close(int fd){
    // put here your device handler (close)
    client2remoteFS.flush(); 
    client2remoteFS.stop(); 
};


void WiFiFSinit() {

  ESP_ERROR_CHECK(esp_vfs_register("/server_fs", &esp_vfs_WiFi_server, NULL)); 
  ESP_ERROR_CHECK(esp_vfs_register("/client_fs", &esp_vfs_WiFi_client, NULL));   

  serverFS.begin(80);
  delay(100); 
} ;
